#!/usr/bin/env bash

replace() {
    echo "Replacing '${1}' with '${2}'..."
    sed --in-place "s|${1}|${2}|g" ./*.xml
}

echo
echo "Awesome Hadoop Configuration Script by Mr. Fluffers"
echo "---------------------------------------------------"

echo
echo "-- Host setup --"

echo -n "NameNode hostname (e.g., orionXX): "
read namenode

echo -n "Secondary Namenode hostname:       "
read secondary

echo -n "ResourceManager hostname:          "
read resource

echo
echo "-- Port Setup --"
echo "Example: if your port range is 14000–14999, enter 140 for your prefix."
echo -n "Port Prefix: "
read prefix

username=$(whoami)

echo
echo "Configuration"
echo "-------------"
echo "Username:        ${username}"
echo "Port Prefix:     ${prefix}"
echo "NameNode:        ${namenode}"
echo "SecondaryNN:     ${secondary}"
echo "ResourceManager: ${resource}"
echo

echo -n "Is this ok? [y/N] "
read ok

if [[ "${ok}" != "y" ]]; then
    echo "Bye!"
    exit 1
fi

echo "Making backup of original configuration files..."
mkdir -p ./backup
cp -rv *.xml ./backup
echo

echo "Configuring..."
replace TODO-USERNAME "${username}"
replace PORTPREFIX "${prefix}"
replace TODO-NAMENODE "${namenode}"
replace TODO-SECONDARYNN "${secondary}"
replace TODO-RESOURCEMANAGER "${resource}"
replace TODO-RESOURCEMANAGER "${resource}"
echo

echo "Done! Hopefully that actually worked... If there were problems, the"
echo "original files are available in the backup directory."
echo
echo "Have a nice day!"
